"""
 functions to match a bunch of fragment descriptors from a file

No user-servicable parts inside.  ;-)

"""
from __future__ import annotations
import os as os
from rdkit import Chem
from rdkit import RDConfig
__all__ = ['Chem', 'RDConfig', 'defaultPatternFileName', 'fn', 'fns', 'name', 'os']
def _CountMatches(mol, patt, unique = True):
    ...
def _LoadPatterns(fileName = None):
    ...
defaultPatternFileName: str = '/project/build/temp.linux-aarch64-cpython-38/rdkit_install/share/RDKit/Data/FragmentDescriptors.csv'
fn = None
fns: list  # value = [('fr_C_O', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224820>), ('fr_C_O_noCOO', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2248b0>), ('fr_Al_OH', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224940>), ('fr_Ar_OH', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2249d0>), ('fr_methoxy', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224a60>), ('fr_oxime', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224af0>), ('fr_ester', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224b80>), ('fr_Al_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224c10>), ('fr_Ar_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224ca0>), ('fr_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224d30>), ('fr_COO2', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224dc0>), ('fr_ketone', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224e50>), ('fr_ether', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224ee0>), ('fr_phenol', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a224f70>), ('fr_aldehyde', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c040>), ('fr_quatN', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c0d0>), ('fr_NH2', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c160>), ('fr_NH1', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c1f0>), ('fr_NH0', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c280>), ('fr_Ar_N', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c310>), ('fr_Ar_NH', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c3a0>), ('fr_aniline', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c430>), ('fr_Imine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c4c0>), ('fr_nitrile', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c550>), ('fr_hdrzine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c670>), ('fr_hdrzone', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c5e0>), ('fr_nitroso', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c700>), ('fr_N_O', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c790>), ('fr_nitro', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c820>), ('fr_azo', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c8b0>), ('fr_diazo', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c940>), ('fr_azide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22c9d0>), ('fr_amide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22ca60>), ('fr_priamide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22caf0>), ('fr_amidine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cb80>), ('fr_guanido', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cc10>), ('fr_Nhpyrrole', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cca0>), ('fr_imide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cd30>), ('fr_isocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cdc0>), ('fr_isothiocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22ce50>), ('fr_thiocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cee0>), ('fr_halogen', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22cf70>), ('fr_alkyl_halide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f040>), ('fr_sulfide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f0d0>), ('fr_SH', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f160>), ('fr_C_S', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f1f0>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f280>), ('fr_sulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f310>), ('fr_prisulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f3a0>), ('fr_barbitur', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f430>), ('fr_urea', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f4c0>), ('fr_term_acetylene', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f550>), ('fr_imidazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f5e0>), ('fr_furan', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f670>), ('fr_thiophene', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f700>), ('fr_thiazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f790>), ('fr_oxazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f820>), ('fr_pyridine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f8b0>), ('fr_piperdine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f940>), ('fr_piperzine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22f9d0>), ('fr_morpholine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fa60>), ('fr_lactam', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22faf0>), ('fr_lactone', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fb80>), ('fr_tetrazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fc10>), ('fr_epoxide', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fca0>), ('fr_unbrch_alkane', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fe50>), ('fr_bicyclic', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fd30>), ('fr_benzene', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22fee0>), ('fr_phos_acid', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a22ff70>), ('fr_phos_ester', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233040>), ('fr_nitro_arom', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2330d0>), ('fr_nitro_arom_nonortho', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233160>), ('fr_dihydropyridine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233280>), ('fr_phenol_noOrthoHbond', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2331f0>), ('fr_Al_OH_noTert', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233310>), ('fr_benzodiazepine', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2333a0>), ('fr_para_hydroxylation', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233430>), ('fr_allylic_oxid', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233550>), ('fr_aryl_methyl', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2334c0>), ('fr_Ndealkylation1', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2335e0>), ('fr_Ndealkylation2', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233670>), ('fr_alkyl_carbamate', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233700>), ('fr_ketone_Topliss', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233790>), ('fr_ArN', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a233820>), ('fr_HOCCN', <function _LoadPatterns.<locals>.<lambda> at 0xffff8a2338b0>)]
name: str = 'fr_HOCCN'
